# Deadlock Coding

Extension VSCode permettant de :

- récupérer la mission en cours à partir du `/home/config/user-challenge.json`
- afficher les consignes de la mission depuis un `README.md`.

## Quick start

- Ouvrir le dossier `deadlock-extension` dans Vscode
- Lancer le script `setup-dev-env.sh` pour simuler la configuration d'une mission
- Lancer le script `install.sh`
- Dans l'éditeur, appuyer sur `F5` (ou utiliser l'onglet `Run and Debug`).

## Gitlab CI pour publier l'extension

Le pipeline a besoin d'un token provenant de la marketplace pour y publier l'extension.

- La méthode pour obtenir le token est décrite [ici](https://code.visualstudio.com/api/working-with-extensions/publishing-extension#get-a-personal-access-token)
- Le token doit être inséré en tant que valeur de la variable `VSCODE_EXTENSION_MARKET_PLACE_ACCESS_TOKEN`

**Le token a une durée de vie maximale de 1 an**

## Gestion de la production et de la pré-production

Pour le moment, la marketplace de Vscode ne supporte pas totalement le `semver`([spécialement les suffixes](https://github.com/microsoft/vsmarketplace/issues/50#issuecomment-990764201)). Il n'est pas possible de créer une version `0.0.1-alpha` de l'extension par example.

### Construire une version pré-release

1. Monter la version de l'extension avec `npm version`. Vous pouvez voir comment utiliser la commande [ici](https://docs.npmjs.com/cli/v8/commands/npm-version).

2. Lorsque le travail est poussé sur la branche `master`, une version de l'extension est poussé en `pre-release` sur la marketplace.

### Constuire une version release

1. Monter la version de l'extension avec `npm version`. Vous pouvez voir comment utiliser la commande [ici](https://docs.npmjs.com/cli/v8/commands/npm-version).

2. Pousser le code source et le tag :

```shell
git tag [X.Y.Z]
git push origin [taBranch] --tags
```

### Publier l'extention à la main

Les commandes nécessaires sont prédéfinies dans le package.json :

```shell
npm run vsce-package
npm run vsce-publish -- [--pre-release] -p [token]
```

La méthode pour obtenir le token est décrite [ici](https://code.visualstudio.com/api/working-with-extensions/publishing-extension#get-a-personal-access-token)

## Le cas d'usage à essayer

Le cas d'usage à essayer pour valider une US Deadlock Desktop correspond à un scénario utilisateur. Ce scénario doit être mis à jour à chaque mise à jour.

Configuration de base :

- OS: Ubuntu 20.04.4 LTS
- Navigateur: Mozilla Firefox (v99.0+), Google Chrome (v101.0+)
- Docker version 20.10.14, build a224086
- Visual Studio Code (v1.66.2+)

Steps:

**Avec un compte étudiant**
1. Aller sur https://www.dev.deadlock.io/. La page d'authentification doit apparaitre.
2. Se connecter via Google. Être redirigé vers la page d'accueil.
3. Sélectionner et lancer une mission du type `desktop`. Les instructions de la mission doivent apparaître sur la page ainsi qu'un briefing sur l'utilisation des commandes si elles existent.
4. Tous les liens sur la page de la mission doivent fonctionner : installation de dépendances, la page de l'extension sur la marketplace, et le lien xdg-open permettant d'ouvrir Vscode.
5. Lorsque VS Code est ouvert, une fenêtre doit apparaitre et suggérer l'installation de l'extension. Accepter l'installation. L'installation doit fonctionner et une notification de bienvenue doit apparaître.
6. Désinstaller l'extension, relancer l'IDE et chercher `deadlock` dans la barre de recherche de la `marketplace`. L'extension doit apparaitre dans les 3 premiers résultats. Reinstaller l'extension.
7. Re-cliquer sur le lien de l'exercice dans le navigateur.
8. S'authentifier avec Google.
10. Une fois authentifié, VSCode doit se rouvrir automatiquement dans le `devcontainer`. L'arborescence de fichiers doit être montée dans le dossier des exercices.
11. Ouvrir le terminal de VSCode. L'utilisateur en cours doit être `deadlock` et les bibliothèques et exécutables nécessaires à la mission doivent être présents (ex: docker, java, node, ...).
12. Essayer de modifier le code et le sauvegarder
13. Essayer de lancer les commandes de l'extension
14. Essayer de lancer des commandes `docker`(ex: `docker ps`)
14. Réaliser un submit de l'exercice
15. Fermer l'exercice et se déconnecter
16. Retourner sur le navigateur et ouvrir l'exercice 
17. Les modifications réalisées doivent être présentes
18. Fermer l'exercice
19. Se déconnecter

**Avec un compte professeur**
1. Aller sur https://www.dev.deadlock.io/. La page d'authentification doit apparaitre.
2. Se connecter via Google. Être redirigé vers la page d'accueil.
3. Ouvrir la liste des étudiants
4. Sélectionner l'étudiant qui vient de réaliser l'exercice desktop. Des statistiques doivent être présentes sur la page. 
5. Cliquer sur l'exercice **desktop** réalisé par l'étudiant.
6. S'authentifier avec Google.
7. Une fois authentifié, VSCode doit se rouvrir automatiquement dans le `devcontainer`. 
8. Vérifier que l'extension Gitlens est bien disponible.
9. Vérifier que les modifications de l'utilisateur sont disponibles
